<table mat-table [dataSource]="this.dataSource" matSort style="width: 100%">
  <!-- Columns -->
  <ng-container
    matColumnDef="select"
    *ngIf="
      this.defaultSettings.showSelectionColumn &&
      this.defaultSettings.allowMultipleSelection
    "
  >
    <th mat-header-cell *matHeaderCellDef>
      <mat-checkbox
        style="position: relative; top: -1.5px"
        (change)="$event ? toggleAllRows() : null"
        [checked]="
          this.tableService.selectionData.hasValue() && isAllSelected()
        "
        [indeterminate]="
          this.tableService.selectionData.hasValue() && !isAllSelected()
        "
      >
      </mat-checkbox>
    </th>
    <td
      mat-cell
      *matCellDef="let row"
      [class.clicked-row]="this.tableService.selectionData.isSelected(row)"
    >
      <mat-checkbox
        style="position: relative; top: -1.5px"
        (click)="$event.stopPropagation()"
        (change)="$event ? this.tableService.selectionData.toggle(row) : null"
        [checked]="this.tableService.selectionData.isSelected(row)"
      >
      </mat-checkbox>
    </td>
  </ng-container>

  <ng-container *ngFor="let options of this.tableFields">
    <ng-container [matColumnDef]="options.field">
      <th
        mat-header-cell
        *matHeaderCellDef
        mat-sort-header
        [disabled]="disableSort(this.defaultSettings.allowSort, options.sort)"
      >
        <div fxLayout="column" fxLayoutAlign="center center" fxFlexAlign="center">
          <ng-container>
            {{ options.label }}
          </ng-container>
          <ng-container>
            <mat-form-field appearance="legacy">
              <mat-label>Filtro</mat-label>
              <!-- (click)="this.createCustomFilter(options.field)"  -->
              <input matInput (input)="this.executeFilter($event.target, options.field)" placeholder="Placeholder">
              <mat-icon matSuffix>sentiment_very_satisfied</mat-icon>
            </mat-form-field>
          </ng-container>
        </div>
      </th>

      <td
        mat-cell
        [ngStyle]="{
          'text-align': options.position ? options.position : 'center'
        }"
        *matCellDef="let row"
        (click)="$event.preventDefault(); selectRow(row)"
        [class.clicked-row]="this.tableService.selectionData.isSelected(row)"
      >
        {{ row[options.field] }}
      </td>
    </ng-container>
  </ng-container>

  <ng-container
    *ngIf="this.defaultSettings.showOptionsColumn"
    matColumnDef="options"
  >
    <th mat-header-cell *matHeaderCellDef style="text-align: center">
      {{ this.defaultSettings.optionsLabel }}
    </th>
    <td
      mat-cell
      *matCellDef="let element"
      style="width: 10%"
      [class.clicked-row]="this.tableService.selectionData.isSelected(element)"
    >
      <div fxLayout="row" fxLayoutGap="5px" fxLayoutAlign="center center">
        <button mat-icon-button>
          <mat-icon
            class="tableIcon"
            (click)="$event.stopPropagation(); this.createFunction()"
            >add_shopping_cart</mat-icon
          >
        </button>
      </div>
    </td>
  </ng-container>

  <tr mat-header-row *matHeaderRowDef="this.displayColumn"></tr>
  <tr mat-row *matRowDef="let row; columns: this.displayColumn"></tr>

  <!-- Row shown when there is no matching data. -->
  <tr class="mat-row" *matNoDataRow>
    <td class="mat-cell" colspan="4">No se encontraron valores</td>
  </tr>
</table>

<mat-paginator
  [pageSizeOptions]="this.defaultSettings.paginationSize"
  #paginator
  showFirstLastButtons
>
</mat-paginator>
